package com.steerinfo.dil.controller;

import com.steerinfo.dil.service.impl.OtherWarehouseServiceImpl;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Controller
@RequestMapping("/${api.version}/otherWarehouse")
public class OtherWarehouseController extends BaseRESTfulController {

    @Autowired
    OtherWarehouseServiceImpl otherWarehouseService;

    /**
     * 推送出厂车辆数据到异地库
     *
     * @param orderId
     * @return
     */
    @ApiModelProperty(value = "推送出厂车辆数据到异地库")
    @PostMapping("/sendMessageToOtherWarehouse")
    public RESTfulResult sendMessageToOtherWarehouse(@RequestParam BigDecimal orderId) {
        Map<String,Object> resultMap = otherWarehouseService.sendMessageToOtherWarehouse(orderId);
        return success(resultMap);
    }
}
