package com.steerinfo.dil.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.steerinfo.dil.mapper.TmstrainQualityResultMapper;
import com.steerinfo.dil.mapper.TmstruckQualityResultMapper;
import com.steerinfo.dil.model.TmstrainQualityResult;
import com.steerinfo.dil.model.TmstruckQualityResult;
import com.steerinfo.dil.service.ITmstrainQualityResultService;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.dil.util.XmlToJsonUtil;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;
import org.dom4j.DocumentException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.Date;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * TmstrainQualityResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-07-11 04:12
 * 类描述
 * 修订历史：
 * 日期：2022-07-11
 * 作者：generator
 * 参考：
 * 描述：TmstrainQualityResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmstrainQualityResultService")
public class TmstrainQualityResultServiceImpl implements ITmstrainQualityResultService {

    @Autowired
    TmstrainQualityResultMapper tmstrainQualityResultMapper;
    @Autowired
    TmstruckQualityResultMapper tmstruckQualityResultMapper;


    //定时访问质检系统，获取质检实绩
    @Scheduled(cron = "30 9 10 * * ?")
//    @Override
    public int insertTmstrainQualityResult() throws IOException, DocumentException {
        //先查出所有需要质检的但是没有质检的磅单号
        List<Map<String,Object>> mapList=tmstrainQualityResultMapper.selectWzInputId();
        //System.out.println(mapList);
        if (mapList.size() != 0){
            for (Map<String,Object> map:mapList
            ) {
                BigDecimal  resultTotalId= (BigDecimal) map.get("resultTotalId");
                String capacityNumber = (String) map.get("cargonNo");
                String grossWeightTime = (String) map.get("grossWeightTime");
                String WzInputId = grossWeightTime + capacityNumber;
                //		1. 创建 HttpClient 的实例
                CloseableHttpClient httpClient = HttpClientBuilder.create().build();
                //		2. 创建某种连接方法的实例
                HttpGet httpGet = new HttpGet("http://172.16.33.106:40003/DG_Interface.asmx/Get_Quality_Info?WzInputId="+WzInputId);
                //		3. 调用第一步中创建好的实例的execute方法来执行第二步中创建好的链接类实例
                HttpResponse httpResponse = httpClient.execute(httpGet);
                //		4. 读response获取HttpEntity
                if (httpResponse.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
                    HttpEntity entity = httpResponse.getEntity();
                    //System.out.println(entity);
                    //		5. 对得到后的内容进行处理
                    String result = EntityUtils.toString(entity, "utf-8");
                    //System.out.println(result);
                    try {
                        JSONObject object = XmlToJsonUtil.xmlToJson(result);
                        //System.out.println("-----object------");
                        //System.out.println(object);
                        Map<String, Object>map1 = (Map<String, Object>) object.get("JsonResult");
                        //System.out.println(map1);
                        List mapList2= JSON.parseArray((String) map1.get("jsonResult"));
                        if(mapList2.size() == 0){
                            continue;
                        }
                        List<Map<String,Object>>mapList9=mapList2;
                        for (Map<String,Object> map3:mapList9
                        ) {
                            //判断是否生成报告单，如果生成则生成质检实绩，否则退出
                            Object value =  map3.get("REPORT_ID");
                            if("".equals(value)){
                                continue;
                            }
                            //质检说明
                            String DeductionDescription=(String)map3.get("DEDUCT_SEASON");
                            //获取卸货点
                            String samplePlaceName=(String) map3.get("SAMPLE_PLACE_NAME");
                            //查询卸货点ID
                            BigDecimal SamplePlaceId=tmstruckQualityResultMapper.selectSamplePlaceId(samplePlaceName);
                            //扣水扣杂量
                            BigDecimal Deduction= DataChange.dataToBigDecimal(map3.get("DEDUCT_NUMBER"));
                            //抽样时间
                            Date sampleDate= new Date((String)(map3.get("SAMPLE_DATE")));
                            //设置车皮号
                            String cargo =(String) map3.get("CARGO");
                            //设置物资编号
                            String wz_id =(String) map3.get("WZ_ID");
                            //设置矿点编号
                            String mine_id =(String) map3.get("MINE_ID");
                            //设置合同号
                            String contract_no =(String) map3.get("CONTRACT_NO");
                            //设置供应商编号
                            String supplier_id =(String) map3.get("SUPPLIER_ID");
                            //设置矿种
                            String mine_name =(String) map3.get("MINE_NAME");
                            //设置是否为进口矿国产矿
                            String is_import =(String) map3.get("IS_IMPORT");
                            //获取进厂时间
                            String input_date =(String) map3.get("INPUT_DATE");
                            //获取检验结果
                            String element_value =(String) map3.get("ELEMENT_VALUE");

                            //获取发站
                            //根据磅单号新增相应的质检实绩
                            TmstrainQualityResult tmstrainQualityResult = new TmstrainQualityResult();
                            //设置实绩id
                            tmstrainQualityResult.setResultId(tmstrainQualityResultMapper.selectMaxId());
                            //设置扣水扣杂
                            tmstrainQualityResult.setDeductNumber(Deduction);
                            //设置总实绩id
                            tmstrainQualityResult.setResultTotalId(resultTotalId);
                            //设置进厂流水号
                            tmstrainQualityResult.setWzInputId(WzInputId);
                            //设置卸货点
                            tmstrainQualityResult.setUnloadId(SamplePlaceId);
                            //设置抽样时间
                            tmstrainQualityResult.setSampleDate(sampleDate);
                            //设置质检说明
                            tmstrainQualityResult.setInsertRemark(DeductionDescription);
                            //设置车皮号
                            tmstrainQualityResult.setCargoNo(cargo);
                            //设置检验结果
                            tmstrainQualityResult.setElementValue(element_value);
                            //设置物资编号
                            tmstrainQualityResult.setWzId(wz_id);
                            tmstrainQualityResult.setMineId(mine_id);
                            tmstrainQualityResult.setContranctNo(contract_no);
                            tmstrainQualityResult.setSuplierId(supplier_id);
                            tmstrainQualityResult.setMineName(mine_name);
                            tmstrainQualityResult.setSamplePlaceName(samplePlaceName);
                            tmstrainQualityResult.setIsImport(is_import);
                            tmstrainQualityResult.setInputDate(input_date);
                            tmstrainQualityResult.setInsertTime(new Date());
                            //设置是否抽检状态
                            tmstrainQualityResult.setIsquality("已抽检");
                            tmstrainQualityResultMapper.insertSelective(tmstrainQualityResult);
                        }
                    } catch (DocumentException e) {
                        e.printStackTrace();
                    }
                    EntityUtils.consume(entity);
                } else {
                    System.err.println(httpResponse.getStatusLine());
                }
//		6. 释放连接。无论执行方法是否成功，都必须释放连接
                httpClient.close();
            }
        }
        return 1;
    }

}
